//
//  CustomCollectionView.m
//  testproject
//
//  Created by wulinjie on 2016/11/18.
//  Copyright © 2016年 wulj. All rights reserved.
//

#import "CustomCollectionView.h"
#import "BaseCollectionViewCell.h"
#import "BaseObject.h"
@implementation CustomCollectionView

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/


- (instancetype)initWithFrame:(CGRect)frame
{
    UICollectionViewFlowLayout *layOut = [[UICollectionViewFlowLayout alloc]init];
    layOut.minimumLineSpacing = 5;
    layOut.minimumInteritemSpacing = 2.5;
    self = [super initWithFrame:frame collectionViewLayout:layOut];
    if (self) {
        self.dataList = [[NSMutableArray alloc]init];
        self.delegate =self;
        self.dataSource = self;
        self.backgroundColor = [UIColor whiteColor];
    }
    return self;
}

- (instancetype)initWithFrame:(CGRect)frame collectionViewLayout:(UICollectionViewLayout *)layout
{
    self = [super initWithFrame:frame collectionViewLayout:layout];
    if (self) {
        self.dataList = [[NSMutableArray alloc]init];
        self.delegate = self;
        self.dataSource = self;
        self.backgroundColor = [UIColor whiteColor];
    }
    return self;
}


#pragma mark UICollectionViewDelegate,UICollectionViewDataSource
//高度header
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout referenceSizeForHeaderInSection:(NSInteger)section
{
    id header = self.dataList[section];
    if ([header isKindOfClass:[NSArray class]]) {
        BaseObject *obj = [self.dataList[section] firstObject];
        return obj.collectionViewCellHear;
    }
    else
    {
        BaseObject *obj = self.dataList[section];
        return obj.collectionViewCellHear;
    }
}

//高度footer
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout referenceSizeForFooterInSection:(NSInteger)section
{
    id footer = self.dataList[section];
    if ([footer isKindOfClass:[NSArray class]]) {
        BaseObject *obj = [self.dataList[section] firstObject];
        return obj.collectionViewCellFooter;
    }
    else
    {
        BaseObject *obj = self.dataList[section];
        return obj.collectionViewCellFooter;
    }
}

//大小cell
- (CGSize)collectionView:(UICollectionView *)collectionView
                  layout:(UICollectionViewLayout *)collectionViewLayout
  sizeForItemAtIndexPath:(NSIndexPath *)indexPath {
    id section = self.dataList[indexPath.section];
    if ([section isKindOfClass:[NSArray class]]) {
        NSArray *list = (NSArray *)section;
        BaseObject *obj = list[indexPath.row];
        return obj.collectionViewCellSize;
    }
    else
    {
        BaseObject *obj = self.dataList[indexPath.section];
        return obj.collectionViewCellSize;
    }
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return self.dataList.count; //1.选项 2.项目列  3.公益项
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    id row = self.dataList[section];
    if ([row isKindOfClass:[NSArray class]]) {
        NSArray *list = self.dataList[section];
        return list.count;
    }
    else
        return 1;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    id obj = self.dataList[indexPath.section];
    id item;
    if ([obj isKindOfClass:[NSArray class]]) {
        NSArray *list = (NSArray *)obj;
        item = list[indexPath.row];
    }
    else
        item = obj;
    NSString *class = NSStringFromClass([item class]);
    BaseCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:class forIndexPath:indexPath];
    cell.index = indexPath;
    [cell setObject:obj];
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    NSArray *list = self.dataList[indexPath.section];
    id obj = list[indexPath.row];
    //代理模式
    if ( self.cusomDelegate != nil && [self.cusomDelegate respondsToSelector:@selector(customCollectionView:didClickIndexPath:postObj:)]) {
        [self.cusomDelegate customCollectionView:self didClickIndexPath:indexPath postObj:obj];
    }
}




#pragma mark Register

- (void)registerNib:(nullable UINib *)nib forCellWithReuseClass:(nullable Class)aClass
{
    [self registerNib:nib forCellWithReuseIdentifier:NSStringFromClass([aClass class])];
}

- (void)registerClass:(nullable Class)cellClass forCellWithReuseObject:(nullable  Class)aClass
{
    [self registerClass:cellClass forCellWithReuseIdentifier:NSStringFromClass([aClass class])];
}

- (void)registerNib:(nullable UINib *)nib forSupplementaryViewOfKind:(nullable NSString *)kind withReuseObject:(nullable Class)aClass
{
    [self registerNib:nib forSupplementaryViewOfKind:kind withReuseIdentifier:NSStringFromClass([aClass class])];
}

- (void)registerClass:(nullable Class)viewClass forSupplementaryViewOfKind:(nullable NSString *)elementKind withReuseObject:(nullable Class)aClass
{
    [self registerClass:viewClass forSupplementaryViewOfKind:elementKind withReuseIdentifier:NSStringFromClass([aClass class])];
}



@end
